package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import android.animation.ObjectAnimator
import android.content.Intent
import android.graphics.drawable.AnimationDrawable
import android.os.Handler
import android.os.Looper
import android.widget.ImageView
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.objeto.Objeto
import com.example.ellegadodepintia.minijuegoReparacion.MinijuegoReparacion
import com.example.ellegadodepintia.soundManager.SoundManager

class EfectoReparar(probabilidadExito: Int, private val stringReparado: String, private val stringFallo: String, private val valorPerdido: Int, private val objeto: Objeto) : Efecto(probabilidadExito) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        val probabilidad = (1..100).random()
        soundManager = SoundManager(context!!)
        soundManager.playSound(R.raw.sound_reparar,100)
        val imagenProtagonista = context!!.findViewById<ImageView>(R.id.imagenProtagonista)
        val imagenEfecto = context!!.findViewById<ImageView>(R.id.imagenEfectoEvento)

        imagenProtagonista?.let {
            val salto = ObjectAnimator.ofFloat(it, "translationY", 0f, -40f, 0f)
            salto.duration = 300
            salto.start()

            Handler(Looper.getMainLooper()).postDelayed({
                imagenEfecto?.setImageResource(R.drawable.effect_investigar_animation)
                val efectoAnimacion = imagenEfecto?.drawable as? AnimationDrawable
                efectoAnimacion?.start()
                Handler(Looper.getMainLooper()).postDelayed({
                    imagenEfecto?.setImageDrawable(null)
                }, 400)
            }, 300)
        }

        return if (probabilidad <= probabilidadExito) {
            GameState.eventoActual.actualizarResistencia(GameState.jugador.atributos[Atributo.Investigacion]!!)
            if(GameState.eventoActual.resistenciaActual == GameState.eventoActual.resistenciaMax){

                val intent = Intent(context, MinijuegoReparacion::class.java)
                context!!.startActivityForResult(intent, 100)

                GameState.eventoActual.actualizarFinalizado(true)
                stringReparado + "\n" + GameState.jugador.conseguirObjeto(objeto) + "."
            }else{
                "Consigues reparar la reliquia parcialmente."
            }

        } else {
            GameState.eventoActual.actualizarFinalizado(true)
            GameState.eventoActual.actualizarResistencia(-GameState.eventoActual.resistenciaActual)
            if(GameState.jugador.atributos[Atributo.Investigacion] != 0){
                GameState.jugador.actualizarAtributo(Atributo.Investigacion,-valorPerdido)
                "$stringFallo Pierdes $valorPerdido de investigación."
            }else{
                stringFallo
            }
        }
    }
}
